set	ifinal(*)  Set including goods and final demand;
ifinal(i) = yes;
ifinal("final") = yes;


*	Replace the carbon permits by an equivalent system of
*	differentiated ad-valorem taxes:

tcarb(fe,"final",r)$c0(fe,r)
	 = pcarbon.l(r) * carbcoef(fe,"final",r) / (c0(fe,r)*pa.l(fe,r));
tcarb(fe,i,r)$vafm(fe,i,r) = pcarbon.l(r) * carbcoef(fe,i,r) / (vafm(fe,i,r)*pa.l(fe,r));

*	Verify the equilibrium:

pcarbon.l(r) = 0;
pcemit.l(i,r) = 0;
rtax(r) = 0;
ttax(r) = 0;
gtap.iterlim = 0;

loop(time(t),
$include gtap.gen
	solve gtap using mcp;
);

parameter	consum(r,*)	Consumption level at initial and final points,
		tcarbon		Target carbon tax rate;

tcarbon(fe,ifinal,r) = tcarb(fe,ifinal,r);

loop(time(t),

*	Round to the nearest percentage and then recompute
*	the target:

	tcarb(fe,ifinal,r) = round(tcarb(fe,ifinal,r), 2);
	option tcarb:2; display tcarb;

	gtap.iterlim = 8000;
$include gtap.gen
	solve gtap using mcp;
	consum(r,"tax") = c.l(r);

	tcarb(fe,ifinal,r) =0;
$include gtap.gen
	solve gtap using mcp;
	consum(r,"notax") = c.l(r);
);

set		step	Steps in the line integral /s0*s20/;

scalar		delta	Differencing step for integral calculation /1.e-4/;

parameter	alpha	Fraction of tax applied
		grad	Gradient of C wrt instrument;

alpha(step) = (ord(step)-1)/(card(step)-1);

alias (fe,ffe);

loop(step,

	tcarb(fe,ifinal,r) = alpha(step) * tcarbon(fe,ifinal,r);

	loop(time(t),
$include gtap.gen
	  solve gtap using mcp;
	);

	consum(r,"ref") = c.l(r);

*	Compute derivatives:

	loop((ffe,ifinal,rr)$tcarbon(ffe,ifinal,rr),

	  tcarb(ffe,ifinal,rr) = tcarb(ffe,ifinal,rr) + delta;

	  loop(time(t),
$include gtap.gen
	    solve gtap using mcp;
	  );

	  tcarb(ffe,ifinal,rr) = tcarb(ffe,ifinal,rr) - delta;
	  grad(r,ffe,ifinal,rr) = (c.l(r) - consum(r,"ref")) / delta;
	);
);

